#include <tcl.h>
#include <tk.h>

char *LongAdd(char *Add1, char *Add2);

static Tcl_Interp *global_interp;

char *__StrCat(char *src1, char *src2)
{
	char *result;

	result = malloc(strlen(src1)+strlen(src2)+1);
	memset(result, NULL, strlen(src1)+strlen(src2)+1);
	strcpy(result, src1);
	strcat(result, src2);

	return (char *)result;
}

int LongIsMax(char *Num1, char *Num2)
{
	char *shft = "";
	int l1, l2, i;

	if (Num1 != NULL ) {
		if(!strcmp(Num1, "0") || !strcmp(Num1, "")) return 2;
	}
	if (Num2 != NULL ) {
		if(!strcmp(Num2, "0") || !strcmp(Num2, "")) return 1;
	}

	l1 = strlen(Num1);
	l2 = strlen(Num2);

	if (l1>l2) {
		for (i=0; i<(l1-l2); i++) shft = __StrCat(shft, "0");
		Num2 = __StrCat(shft, Num2);
	} else {
		for (i=0; i<(l2-l1); i++) shft = __StrCat(shft, "0");
		Num1 = __StrCat(shft, Num1);
	}

	if(!strcmp(Num1, Num2)) return 3;

	for(i=0; i<strlen(Num1); i++) {
		if(*(Num1+i) > *(Num2+i)) {
			return 1;
		} else if(*(Num1+i) < *(Num2+i)) {
			return 2;
		}
	}
	
	return -1;
}

char *LongMult2(int Count)
{
	char *Temp = "1";
	while(Count>=0) {
		Temp = LongAdd(Temp, Temp);
		Count--;
	}
	return (char *)Temp;
}

char *LongAdd(char *Add1, char *Add2) 
{
	int Temp;
	int l1, l2;
	int i, s = 0;
	char *shft = "";
	char *Res = "";
	char buff[1024];

	if (Add1 != NULL ) {
		if(!strcmp(Add1, "0") || !strcmp(Add1, "")) return Add2;
	}
	if (Add2 != NULL ) {
		if(!strcmp(Add2, "0") || !strcmp(Add2, "")) return Add1;
	}

	l1 = strlen(Add1);
	l2 = strlen(Add2);

	if (l1>l2) {
		for (i=0; i<(l1-l2); i++) shft = __StrCat(shft, "0");
		Add2 = __StrCat(shft, Add2);
	} else {
		for (i=0; i<(l2-l1); i++) shft = __StrCat(shft, "0");
		Add1 = __StrCat(shft, Add1);
	}

	l1 = strlen(Add1);
	for (i=l1; i>0; i--) {
		char a1[2], a2[2];
		
		sprintf(a1, "%c", *(Add1+i-1));
		sprintf(a2, "%c", *(Add2+i-1));
		
		Temp = atoi(a1) + atoi(a2) + s;
		sprintf(buff, "%d", Temp%10);
		Res = __StrCat(buff, Res);
		s = (Temp>9) ? (Temp/10) : 0;
	}
	
	if (s!=0) {
		sprintf(buff, "%d", s);
		Res = __StrCat(buff, Res);
	}

	return (char *)Res;
}

char *LongDec2Bin (char *Num)
{
	char *Result = "";
	char *Res = "";
	char *_Res = "";
	char *Temp = "1";
	int Msb = 0;
	int Count = 0;

	if(Num==NULL) return "0";
	if(!strlen(Num)) return "0";

	while(1) {
		if(*(Num+Count)!='0') break;
		if(Count==strlen(Num)-1) return "0";
		Count++;
	}

	while(1) {
		Temp = LongAdd(Temp, Temp);
		if(LongIsMax(Temp, Num)==1) {
			break;
		}
		Msb++;
	}
	--Msb;

	for(Count=Msb; Count>=-1; Count--) {
		Temp = LongMult2(Count);
		if(Count==Msb) {
			Result = __StrCat(Result, "1");
			Res = Temp;
		} else {
			_Res = Res;
			Res = LongAdd(Res, Temp);
			if (LongIsMax(Res, Num)==1) {
				Res = _Res;
				Result = __StrCat(Result, "0");
			} else {
				Result = __StrCat(Result, "1");
			}
		}
	}

	return (char *)Result;
}

char *LongDec2Hex (char *Num) {
	int i;
	int Count = 0;
	char *Temp = "";
	char *Res;
	char Bit[2];
	char *Result = "";
	
	Res = LongDec2Bin(Num);
	
	for(i=strlen(Res); i>=0; i--) {
		if((Count%4)==1 && strlen(Temp)) {
			int HexNum = 0;

			if(*(Temp+0)=='1') HexNum+=1;
			if(*(Temp+1)=='1') HexNum+=2;
			if(*(Temp+2)=='1') HexNum+=4;
			if(*(Temp+3)=='1') HexNum+=8;
			switch(HexNum) {
				case 10: Result = __StrCat("A", Result); break;
				case 11: Result = __StrCat("B", Result); break;
				case 12: Result = __StrCat("C", Result); break;
				case 13: Result = __StrCat("D", Result); break;
				case 14: Result = __StrCat("E", Result); break;
				case 15: Result = __StrCat("F", Result); break;
				default: {
					char temp[2];
					sprintf(temp, "%d", HexNum);
					Result = __StrCat(temp, Result);
				}
			}
			
			Temp = "";
		}
		Count++;
		sprintf(Bit, "%c", *(Res+i));
		Temp = __StrCat(Temp, Bit);
	}
	if(strlen(Temp)) {
		int HexNum = 0;

		if(*(Temp+0)=='1') HexNum+=1;
		if(*(Temp+1)=='1') HexNum+=2;
		if(*(Temp+2)=='1') HexNum+=4;
		if(*(Temp+3)=='1') HexNum+=8;
		switch(HexNum) {
			case 10: Result = __StrCat("A", Result); break;
			case 11: Result = __StrCat("B", Result); break;
			case 12: Result = __StrCat("C", Result); break;
			case 13: Result = __StrCat("D", Result); break;
			case 14: Result = __StrCat("E", Result); break;
			case 15: Result = __StrCat("F", Result); break;
			default: {
				char temp[2];
				sprintf(temp, "%d", HexNum);
				Result = __StrCat(temp, Result);
			}
		}
	}

	return (char *)Result;
}

char *LongBin2Dec(char *Num) {
	int i = 0;
	int Msb;
	int Count = 0;
	char *Temp = "0";
	char *Result = "0";

	if(Num==NULL) return "0";
	
	i = strlen(Num)-1;
	while(1) {
		if(*(Num+i)=='1') {
			Temp = LongMult2(Count-1);
			Result = LongAdd(Result, Temp);
		}
		if(i==0) break;
		i--;
		Count++;
	}

	return (char *)Result;
}

char *LongBin2Hex(char *Num) {
	char *Temp;
	char *Result;

	if(Num==NULL) return "0";

	Temp = LongBin2Dec(Num);
	Result = LongDec2Hex(Temp);

	return (char *)Result;
}

char *LongHex2Bin(char *Num) {
	char *Result = "";
	int i;

	for(i=0; i<=strlen(Num); i++) {
		switch(*(Num+i)) {
			case '0':
				Result = __StrCat(Result, "0000"); break;
			case '1':
				Result = __StrCat(Result, "0001"); break;
			case '2':
				Result = __StrCat(Result, "0010"); break;
			case '3':
				Result = __StrCat(Result, "0011"); break;
			case '4':
				Result = __StrCat(Result, "0100"); break;
			case '5':
				Result = __StrCat(Result, "0101"); break;
			case '6':
				Result = __StrCat(Result, "0110"); break;
			case '7':
				Result = __StrCat(Result, "0111"); break;
			case '8':
				Result = __StrCat(Result, "1000"); break;
			case '9':
				Result = __StrCat(Result, "1001"); break;
			case 'a':
			case 'A':
				Result = __StrCat(Result, "1010"); break;
			case 'b':
			case 'B':
				Result = __StrCat(Result, "1011"); break;
			case 'c':
			case 'C':
				Result = __StrCat(Result, "1100"); break;
			case 'd':
			case 'D':
				Result = __StrCat(Result, "1101"); break;
			case 'e':
			case 'E':
				Result = __StrCat(Result, "1110"); break;
			case 'f':
			case 'F':
				Result = __StrCat(Result, "1111");
		}
	}

	return (char *)Result;
}

char *LongHex2Dec(char *Num) {
	char *Temp;
	char *Result;

	if(Num==NULL) return "0";

	Temp = LongHex2Bin(Num);
	Result = LongBin2Dec(Temp);

	return (char *)Result;
}

static int basebin2dec_HandleProc(
        ClientData data, Tcl_Interp *interp, int objc, Tcl_Obj *CONST objv[])
{
	char *str;

	if(objc != 2) {
		Tcl_WrongNumArgs(interp, 1, objv, "binary");
		return TCL_OK;
	}
	
	str = LongBin2Dec(Tcl_GetString(objv[1]));
	if(str==NULL) {
		Tcl_SetObjResult(interp, Tcl_NewStringObj("", -1));
		return TCL_OK;
	} else {
		if(!strlen(str)) {
			Tcl_SetObjResult(interp, Tcl_NewStringObj("", -1));
			return TCL_OK;
		}
	}

	Tcl_SetObjResult(interp, Tcl_NewStringObj(str, -1));
	return TCL_OK;
}

static int basebin2hex_HandleProc(
        ClientData data, Tcl_Interp *interp, int objc, Tcl_Obj *CONST objv[])
{
	char *str;

	if(objc != 2) {
		Tcl_WrongNumArgs(interp, 1, objv, "binary");
		return TCL_OK;
	}
	
	str = LongBin2Hex(Tcl_GetString(objv[1]));
	if(str==NULL) {
		Tcl_SetObjResult(interp, Tcl_NewStringObj("", -1));
		return TCL_OK;
	} else {
		if(!strlen(str)) {
			Tcl_SetObjResult(interp, Tcl_NewStringObj("", -1));
			return TCL_OK;
		}
	}

	Tcl_SetObjResult(interp, Tcl_NewStringObj(str, -1));
	return TCL_OK;
}

static int basedec2bin_HandleProc(
        ClientData data, Tcl_Interp *interp, int objc, Tcl_Obj *CONST objv[])
{
	char *str;

	if(objc != 2) {
		Tcl_WrongNumArgs(interp, 1, objv, "decimal");
		return TCL_OK;
	}
	
	str = LongDec2Bin(Tcl_GetString(objv[1]));
	if(str==NULL) {
		Tcl_SetObjResult(interp, Tcl_NewStringObj("", -1));
		return TCL_OK;
	} else {
		if(!strlen(str)) {
			Tcl_SetObjResult(interp, Tcl_NewStringObj("", -1));
			return TCL_OK;
		}
	}

	Tcl_SetObjResult(interp, Tcl_NewStringObj(str, -1));
	return TCL_OK;
}

static int basedec2hex_HandleProc(
        ClientData data, Tcl_Interp *interp, int objc, Tcl_Obj *CONST objv[])
{
	char *str;

	if(objc != 2) {
		Tcl_WrongNumArgs(interp, 1, objv, "decimal");
		return TCL_OK;
	}
	
	str = LongDec2Hex(Tcl_GetString(objv[1]));
	if(str==NULL) {
		Tcl_SetObjResult(interp, Tcl_NewStringObj("", -1));
		return TCL_OK;
	} else {
		if(!strlen(str)) {
			Tcl_SetObjResult(interp, Tcl_NewStringObj("", -1));
			return TCL_OK;
		}
	}

	Tcl_SetObjResult(interp, Tcl_NewStringObj(str, -1));
	return TCL_OK;
}

static int basehex2bin_HandleProc(
        ClientData data, Tcl_Interp *interp, int objc, Tcl_Obj *CONST objv[])
{
	char *str;

	if(objc != 2) {
		Tcl_WrongNumArgs(interp, 1, objv, "hexadecimal");
		return TCL_OK;
	}
	
	str = LongHex2Bin(Tcl_GetString(objv[1]));
	if(str==NULL) {
		Tcl_SetObjResult(interp, Tcl_NewStringObj("", -1));
		return TCL_OK;
	} else {
		if(!strlen(str)) {
			Tcl_SetObjResult(interp, Tcl_NewStringObj("", -1));
			return TCL_OK;
		}
	}

	Tcl_SetObjResult(interp, Tcl_NewStringObj(str, -1));
	return TCL_OK;
}

static int basehex2dec_HandleProc(
        ClientData data, Tcl_Interp *interp, int objc, Tcl_Obj *CONST objv[])
{
	char *str;

	if(objc != 2) {
		Tcl_WrongNumArgs(interp, 1, objv, "hexadecimal");
		return TCL_OK;
	}
	
	str = LongHex2Dec(Tcl_GetString(objv[1]));
	if(str==NULL) {
		Tcl_SetObjResult(interp, Tcl_NewStringObj("", -1));
		return TCL_OK;
	} else {
		if(!strlen(str)) {
			Tcl_SetObjResult(interp, Tcl_NewStringObj("", -1));
			return TCL_OK;
		}
	}

	Tcl_SetObjResult(interp, Tcl_NewStringObj(str, -1));
	return TCL_OK;
}

static int ishex_HandleProc(
        ClientData data, Tcl_Interp *interp, int objc, Tcl_Obj *CONST objv[])
{
	int i;
	char *str;

	if(objc != 2) {
		Tcl_WrongNumArgs(interp, 1, objv, "hexadecimal");
		return TCL_OK;
	}

	str = strdup(Tcl_GetString(objv[1]));
	for(i=0; i < strlen(str); i++) {
		if( *(str+i)=='0' || *(str+i)=='1' || *(str+i)=='2' || *(str+i)=='3' ||
			*(str+i)=='4' || *(str+i)=='5' || *(str+i)=='6' || *(str+i)=='7' ||
			*(str+i)=='8' || *(str+i)=='9' || *(str+i)=='a' || *(str+i)=='b' ||
			*(str+i)=='c' || *(str+i)=='d' || *(str+i)=='e' || *(str+i)=='f' ||
			*(str+i)=='A' || *(str+i)=='B' || *(str+i)=='C' || *(str+i)=='D' ||
			*(str+i)=='E' || *(str+i)=='F' ) {
		} else {
			Tcl_SetObjResult(interp, Tcl_NewStringObj("FAILURE", -1));
			return TCL_OK;
		}
	}
	
	Tcl_SetObjResult(interp, Tcl_NewStringObj("SUCCESS", -1));
	return TCL_OK;
}

static int isdec_HandleProc(
        ClientData data, Tcl_Interp *interp, int objc, Tcl_Obj *CONST objv[])
{
	int i;
	char *str;

	if(objc != 2) {
		Tcl_WrongNumArgs(interp, 1, objv, "decimal");
		return TCL_OK;
	}

	str = strdup(Tcl_GetString(objv[1]));
	for(i=0; i < strlen(str); i++) {
		if( *(str+i)=='0' || *(str+i)=='1' || *(str+i)=='2' || *(str+i)=='3' ||
			*(str+i)=='4' || *(str+i)=='5' || *(str+i)=='6' || *(str+i)=='7' ||
			*(str+i)=='8' || *(str+i)=='9' ) {
		} else {
			Tcl_SetObjResult(interp, Tcl_NewStringObj("FAILURE", -1));
			return TCL_OK;
		}
	}
	
	Tcl_SetObjResult(interp, Tcl_NewStringObj("SUCCESS", -1));
	return TCL_OK;
}

static int isbin_HandleProc(
        ClientData data, Tcl_Interp *interp, int objc, Tcl_Obj *CONST objv[])
{
	int i;
	char *str;

	if(objc != 2) {
		Tcl_WrongNumArgs(interp, 1, objv, "binary");
		return TCL_OK;
	}

	str = strdup(Tcl_GetString(objv[1]));
	for(i=0; i < strlen(str); i++) {
		if( *(str+i)=='0' || *(str+i)=='1' ) {
		} else {
			Tcl_SetObjResult(interp, Tcl_NewStringObj("FAILURE", -1));
			return TCL_OK;
		}
	}
	
	Tcl_SetObjResult(interp, Tcl_NewStringObj("SUCCESS", -1));
	return TCL_OK;
}

static int isbin2_HandleProc(
        ClientData data, Tcl_Interp *interp, int objc, Tcl_Obj *CONST objv[])
{
	int i;
	char *str;

	if(objc != 2) {
		Tcl_WrongNumArgs(interp, 1, objv, "binary");
		return TCL_OK;
	}

	str = strdup(Tcl_GetString(objv[1]));
	for(i=0; i < strlen(str); i++) {
		if( *(str+i)=='0' || *(str+i)=='1' ||
			*(str+i)=='x' || *(str+i)=='X' ) {
		} else {
			Tcl_SetObjResult(interp, Tcl_NewStringObj("FAILURE", -1));
			return TCL_OK;
		}
	}
	
	Tcl_SetObjResult(interp, Tcl_NewStringObj("SUCCESS", -1));
	return TCL_OK;
}

DLLEXPORT int Baseconv_Init(Tcl_Interp* interp) {
	Tcl_InitStubs(interp, "8.1", 0);
	
	Tcl_CreateObjCommand(interp, "bin2dec", basebin2dec_HandleProc, NULL, NULL);
	Tcl_CreateObjCommand(interp, "bin2hex", basebin2hex_HandleProc, NULL, NULL);
	Tcl_CreateObjCommand(interp, "dec2bin", basedec2bin_HandleProc, NULL, NULL);
	Tcl_CreateObjCommand(interp, "dec2hex", basedec2hex_HandleProc, NULL, NULL);
	Tcl_CreateObjCommand(interp, "hex2bin", basehex2bin_HandleProc, NULL, NULL);
	Tcl_CreateObjCommand(interp, "hex2dec", basehex2dec_HandleProc, NULL, NULL);
	Tcl_CreateObjCommand(interp, "is_hex", ishex_HandleProc, NULL, NULL);
	Tcl_CreateObjCommand(interp, "is_bin", isbin_HandleProc, NULL, NULL);
	Tcl_CreateObjCommand(interp, "is_bin2", isbin2_HandleProc, NULL, NULL);
	Tcl_CreateObjCommand(interp, "is_dec", isdec_HandleProc, NULL, NULL);
	
	global_interp = interp;
	
	return Tcl_PkgProvide(interp, "baseconv", "1.00");
}
